bash set -e函数有双管道

时间:2016-02-26 12:10:53

标签: linux bash

有人可以解释这种行为吗?这对我来说似乎很奇怪。

#!/bin/bash

set -e

_func() { 
  cat non-existant-file
  return 0
}

_func || echo "Not seen since _func returned zero"
_func
echo "Not seen since _func returned non-zero"

输出(GNU bash,版本4.3.42(1)-release(x86_64-pc-linux-gnu)):

$ bash func.sh 
cat: non-existant-file: No such file or directory
cat: non-existant-file: No such file or directory
$ 

1 个答案:

答案 0 :(得分:5)

如果你查看bash的联机帮助页,它特别提到了这个:

特别是The shell does not exit if the command that fails is part of [...] any command executed in a && or || list except the command following the final && or || [...]

此行为完全符合记录/预期。

如果你运行这样的话,你可以自己看看:

#!/bin/bash

set -ex
# set -x will tell you exactly where the shell exits.

_func() { 
  cat non-existant-file
  return 0
}

#_func || echo "Not seen since _func returned zero"
cat non-existant-file || _func
_func
echo "Not seen since _func returned non-zero"

从联系手册:

    set   -e      Exit immediately if a pipeline (which may consist  of  a
                  single  simple  command),  a list, or a compound command
                  (see SHELL GRAMMAR above),  exits with a  non-zero  sta‐
                  tus.   The shell does not exit if the command that fails
                  is part of the  command  list  immediately  following  a
                  while  or  until keyword, part of the test following the
                  if or elif reserved words, part of any command  executed
                  in  a  &&  or  ||  list except the command following the
                  final && or ||, any command in a pipeline but the  last,
                  or  if the command's return value is being inverted with
                  !.  If a compound command other than a subshell  returns
                  a  non-zero status because a command failed while -e was
                  being ignored, the shell does not exit.  A trap on  ERR,
                  if set, is executed before the shell exits.  This option
                  applies to the shell environment and each subshell envi‐
                  ronment  separately  (see  COMMAND EXECUTION ENVIRONMENT
                  above), and may cause subshells to exit before executing
                  all the commands in the subshell.

这就是你的情况。